/*
	Game Categories v 12.0
	Copyright (C) 2009, Bubbletune

	game_categories.h: Game Categories Header
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <game_categories_info.h>
#include <game_categories_macros.h>
#include <game_categories_structs.h>
#include <game_categories_libc.h>

// Exports from kernel module: communication.c
void gcLibKernelSetPatch(int patch);
u32 gcLibKernelPatchExport(char *modname, char *importlib, u32 nid, void *newone);
u32 gcLibKernelFindProc(const char* szMod, const char* szLib, u32 nid);
int gcLibKernelUTF8ToUnicode(wchar_t *dest, char *src);
SceModule2 *gcLibKernelFindModuleByName(char *modname);
int gcLibKernelGetDevkitID(char *modname);

// Imported from user module: vshmain.prx
int vshGetRegistryValue(u32 *option, char *name, void *arg2, int size, int *value);
int vshSetRegistryValue(u32 *option, char *name, int size,  int *value);

// Imported from user module: paf.prx
wchar_t *scePafGetText(void *, char *);
int scePafGetPageString(void *resource, u32 *data, int *arg2, char **string, int *temp0);
int scePafGetPageChild(void *resource, SceRcoEntry *parent, char *name, SceRcoEntry **child);

// General functions in: linker.S (user)
void AddSysconfItem(u32 *option, SceSysconfItem **item);
SceSysconfItem *GetSysconfItem(void *arg0, void *arg1);
int ExecuteAction(int action, int action_arg);

