#include <pspsdk.h>

u32 sceSysconCmdExec(void *param, int unk);

//Thanks to SilverSpring for the reversed functions
int syscon_write(u8 addr,u16 data)
{
	int ret;
	u8 param[0x60];
	if(addr > 0x7F){
		return 0x80000102;
	}
	
	param[0x0C] = 0x73;
	param[0x0D] = 5;
	param[0x0E] = addr;
	param[0x0F] = data;
	param[0x10] = data >> 8;
	
	ret = sceSysconCmdExec(param,0);
	
	if(ret < 0){
		return ret;
	}
	
	return 0;
}

int syscon_read(u8 addr)
{
	int ret;
	u8 param[0x60];
	if(addr > 0x7F){
		return 0x80000102;
	}
	param[0x0C] = 0x74;
	param[0x0D] = 3;
	param[0x0E] = addr;
	
	ret = sceSysconCmdExec(param,0);
	
	if(ret < 0){
		return ret;
	}
	
	return (param[0x21]<<8) | param[0x20];
}

void SerialWrite(u32 serial)
{
	syscon_write(0x07,serial >> 16); //low
	syscon_write(0x09,serial & 0xFFFF); //high
}

u32 SerialRead(void)
{
	u32 ret = (syscon_read(0x07) << 16 | syscon_read(0x09));
	return ret;
}

int XMBSetMode(int mode)
{
	u32 k1 = pspSdkSetK1(0),old = SerialRead(),new;
	if(mode == 0){
		if(old != 0xFFFFFFFF){
			new = 0xFFFFFFFF;
		}else{
			return 1;
		}
	}else if(mode == 1){
		if((old == 0xFFFFFFFF) || (old == 0x00000000)){
			new = 0x12345678;
		}else{
			return 1;
		}
	}else if(mode == 2){
		if(old != 0x00000000){
			new = 0x00000000;
		}else{
			return 1;
		}
	}
	SerialWrite(new);
	pspSdkSetK1(k1);
	return 0;
}

int XMBGetMode(void)
{
	u32 k1 = pspSdkSetK1(0),old = SerialRead();
	pspSdkSetK1(k1);
	if(old == 0xFFFFFFFF)
		return 0;
	else if((old != 0xFFFFFFFF) && (old != 0x00000000))
		return 1;
	else if(old == 0x00000000)
		return 2;
	
	return -1;
}
	
